=== lib/user/Makefile ===
MKPATH=../../mk/
include $(MKPATH)buildsys.mk

SUBDIRS = archive save scores info
PACKAGE = user
